package net.minecraft.src;
// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) braces deadcode 

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.net.URL;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.IntBuffer;
import java.security.CodeSource;
import java.security.ProtectionDomain;
import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Set;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import javax.imageio.ImageIO;
import net.minecraft.client.Minecraft;
import org.lwjgl.opengl.GL11;

public final class ModLoader
{

    public static Logger getLogger()
    {
        return logger;
    }

    public static int AddAllFuel(int i)
    {
        logger.finest((new StringBuilder("Finding fuel for ")).append(i).toString());
        int j = 0;
        for(int k = 0; k < modList.size() && j == 0; k++)
        {
            j = ((BaseMod)modList.get(k)).AddFuel(i);
        }

        if(j != 0)
        {
            logger.finest((new StringBuilder("Returned ")).append(j).toString());
        }
        return j;
    }

    public static void AddAllRecipes(CraftingManager craftingmanager)
    {
        logger.finer("Initializing recipes");
        for(int i = 0; i < modList.size(); i++)
        {
            ((BaseMod)modList.get(i)).AddRecipes(craftingmanager);
        }

    }

    public static void AddAllRenderers(Map map)
    {
        if(!hasInit)
        {
            init();
            logger.fine("Initialized");
        }
        for(int i = 0; i < modList.size(); i++)
        {
            ((BaseMod)modList.get(i)).AddRenderer(map);
        }

    }

    public static void AddSmelting(int i, ItemStack itemstack)
    {
        FurnaceRecipes.func_21200_a().func_21199_a(i, itemstack);
    }

    public static void addAnimation(TextureFX texturefx)
    {
        logger.finest((new StringBuilder("Adding animation ")).append(texturefx.toString()).toString());
        animList.add(texturefx);
    }

    private static void addMod(ClassLoader classloader, String s)
    {
        try
        {
            String s1 = s.substring(0, s.length() - 6);
            Class class1 = classloader.loadClass(s1);
            if(class1.getSuperclass() != (BaseMod.class))
            {
                return;
            }
            BaseMod basemod = (BaseMod)class1.newInstance();
            if(basemod != null)
            {
                modList.add(basemod);
                logger.fine((new StringBuilder("Mod Loaded: \"")).append(basemod.toString()).append("\" from ").append(s).toString());
                System.out.println((new StringBuilder("Mod Loaded: ")).append(basemod.toString()).toString());
            }
        }
        catch(Exception exception)
        {
            logger.throwing("ModLoader", "addMod", exception);
            exception.printStackTrace();
        }
    }

    public static void AddName(Object obj, String s)
    {
        Properties properties = null;
        try
        {
            properties = (Properties)getPrivateValue(StringTranslate.class, StringTranslate.func_20162_a(), 1);
        }
        catch(SecurityException securityexception)
        {
            ThrowException(securityexception);
        }
        catch(NoSuchFieldException nosuchfieldexception)
        {
            ThrowException(nosuchfieldexception);
        }
        if(properties != null)
        {
            String s1 = null;
            if(obj instanceof Item)
            {
                Item item = (Item)obj;
                if(item.func_20009_a() != null)
                {
                    s1 = (new StringBuilder(String.valueOf(item.func_20009_a()))).append(".name").toString();
                }
            } else
            if(obj instanceof Block)
            {
                Block block = (Block)obj;
                if(block.func_20013_i() != null)
                {
                    s1 = (new StringBuilder(String.valueOf(block.func_20013_i()))).append(".name").toString();
                }
            } else
            if(obj instanceof ItemStack)
            {
                ItemStack itemstack = (ItemStack)obj;
                if(itemstack.func_20109_f() != null)
                {
                    s1 = (new StringBuilder(String.valueOf(itemstack.func_20109_f()))).append(".name").toString();
                }
            } else
            {
                ThrowException(new Exception((new StringBuilder(String.valueOf(obj.getClass().getName()))).append(" cannot have name attached to it!").toString()));
            }
            if(s1 != null)
            {
                properties.put(s1, s);
            } else
            {
                ThrowException(new Exception((new StringBuilder()).append(obj).append(" is missing name tag!").toString()));
            }
        }
    }

    public static void addOverride(String s, String s1, int i)
    {
        logger.finer((new StringBuilder("addOverride(")).append(s).append(",").append(s1).append(",").append(i).append(")").toString());
        Object obj = (List)overrides.get(s);
        if(obj == null)
        {
            obj = new LinkedList();
            overrides.put(s, obj);
        }
        ((List) (obj)).add(new java.util.AbstractMap.SimpleEntry(s1, Integer.valueOf(i)));
    }

    public static List getLoadedMods()
    {
        return Collections.unmodifiableList(modList);
    }

    public static Minecraft getMinecraftInstance()
    {
        if(instance == null)
        {
            try
            {
                ThreadGroup threadgroup = Thread.currentThread().getThreadGroup();
                int i = threadgroup.activeCount();
                Thread athread[] = new Thread[i];
                threadgroup.enumerate(athread);
                for(int j = 0; j < athread.length; j++)
                {
                    if(!athread[j].getName().equals("Minecraft main thread"))
                    {
                        continue;
                    }
                    instance = (Minecraft)getPrivateValue(java.lang.Thread.class, athread[j], "target");
                    break;
                }

            }
            catch(SecurityException securityexception)
            {
                logger.throwing("ModLoader", "getMinecraftInstance", securityexception);
                throw new RuntimeException(securityexception);
            }
            catch(NoSuchFieldException nosuchfieldexception)
            {
                logger.throwing("ModLoader", "getMinecraftInstance", nosuchfieldexception);
                throw new RuntimeException(nosuchfieldexception);
            }
        }
        return instance;
    }

    public static Object getPrivateValue(Class class1, Object obj, int i)
        throws IllegalArgumentException, SecurityException, NoSuchFieldException
    {
        try
        {
            Field field = class1.getDeclaredFields()[i];
            field.setAccessible(true);
            return field.get(obj);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "getPrivateValue", illegalaccessexception);
            ThrowException("An impossible error has occured!", illegalaccessexception);
            return null;
        }
    }

    public static Object getPrivateValue(Class class1, Object obj, String s)
        throws IllegalArgumentException, SecurityException, NoSuchFieldException
    {
        try
        {
            Field field = class1.getDeclaredField(s);
            field.setAccessible(true);
            return field.get(obj);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "getPrivateValue", illegalaccessexception);
            ThrowException("An impossible error has occured!", illegalaccessexception);
            return null;
        }
    }

    public static int getUniqueEntityId()
    {
        return highestEntityId++;
    }

    private static int getUniqueItemSpriteIndex()
    {
        for(; itemSpriteIndex < usedItemSprites.length; itemSpriteIndex++)
        {
            if(!usedItemSprites[itemSpriteIndex])
            {
                usedItemSprites[itemSpriteIndex] = true;
                return itemSpriteIndex++;
            }
        }

        ThrowException(new Exception("No more empty item sprite indices left!"));
        return 0;
    }

    public static int getUniqueSpriteIndex(String s)
    {
        if(s.equals("/gui/items.png"))
        {
            return getUniqueItemSpriteIndex();
        }
        if(s.equals("/terrain.png"))
        {
            return getUniqueTerrainSpriteIndex();
        } else
        {
            ThrowException(new Exception((new StringBuilder("No registry for this texture: ")).append(s).toString()));
            return 0;
        }
    }

    private static int getUniqueTerrainSpriteIndex()
    {
        for(; terrainSpriteIndex < usedTerrainSprites.length; terrainSpriteIndex++)
        {
            if(!usedTerrainSprites[terrainSpriteIndex])
            {
                usedTerrainSprites[terrainSpriteIndex] = true;
                return terrainSpriteIndex++;
            }
        }

        ThrowException(new Exception("No more empty terrain sprite indices left!"));
        return 0;
    }

    private static void init()
    {
        String s = "1111111111111111111111111111111111111101111110011111111111110001111111111111111111111001111001111111100110000111111110000000011111111001100001110000000100000111000000010000011100000000000001110000000000000111000000000000000000000000000000001100000000000000";
        String s1 = "1111111111111111111111111111110111111100011111111111110001111110111111111111000011111111111111111111111111000000111111111111100011101100000010001110000000000000111000000000000011100000000000001110000000000111111000000000001101000000000001111111111111000011";
        for(int i = 0; i < 256; i++)
        {
            usedItemSprites[i] = s.charAt(i) == '1';
            usedTerrainSprites[i] = s1.charAt(i) == '1';
        }

        try
        {
            field_modifiers = (java.lang.reflect.Field.class).getDeclaredField("modifiers");
            field_modifiers.setAccessible(true);
            field_blockList = (Session.class).getDeclaredFields()[0];
            field_blockList.setAccessible(true);
            try
            {
                method_RegisterTileEntity = (TileEntity.class).getDeclaredMethod("a", new Class[] {
                    java.lang.Class.class, java.lang.String.class
                });
            }
            catch(NoSuchMethodException nosuchmethodexception)
            {
                method_RegisterTileEntity = (TileEntity.class).getDeclaredMethod("addMapping", new Class[] {
                    java.lang.Class.class, java.lang.String.class
                });
            }
            method_RegisterTileEntity.setAccessible(true);
            try
            {
                method_RegisterEntityID = (EntityList.class).getDeclaredMethod("a", new Class[] {
                    java.lang.Class.class, java.lang.String.class, Integer.TYPE
                });
            }
            catch(NoSuchMethodException nosuchmethodexception1)
            {
                method_RegisterEntityID = (EntityList.class).getDeclaredMethod("addMapping", new Class[] {
                    java.lang.Class.class, java.lang.String.class, Integer.TYPE
                });
            }
            method_RegisterEntityID.setAccessible(true);
            method_glTexSubImage2D = (org.lwjgl.opengl.GL11.class).getMethod("glTexSubImage2D", new Class[] {
                Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, java.nio.ByteBuffer.class
            });
            
            // TODO
            try
            {
	            field_armorList = RenderPlayer.class.getDeclaredFields()[3];
	            field_modifiers.setInt(field_armorList, field_armorList.getModifiers() & ~Modifier.FINAL);
	            field_armorList.setAccessible(true);
            }
            catch(IllegalAccessException illegalaccessexception)
            {
            	logger.throwing("ModLoader", "init", illegalaccessexception);
                ThrowException("An impossible error has occured!", illegalaccessexception);
            }
            try
            {
                method_AddIdClassMapping = (Packet.class).getDeclaredMethod("a", new Class[] {
                		int.class, Class.class
                });
            }
            catch(NoSuchMethodException nosuchmethodexception1)
            {
            	method_AddIdClassMapping = (Packet.class).getDeclaredMethod("addIdClassMapping", new Class[] {
            			int.class, Class.class
                });
            }
            method_AddIdClassMapping.setAccessible(true);
            
            addCustomPacketMapping();
        }
        catch(SecurityException securityexception)
        {
            logger.throwing("ModLoader", "init", securityexception);
            ThrowException(securityexception);
        }
        catch(NoSuchFieldException nosuchfieldexception)
        {
            logger.throwing("ModLoader", "init", nosuchfieldexception);
            ThrowException(nosuchfieldexception);
        }
        catch(NoSuchMethodException nosuchmethodexception2)
        {
            logger.throwing("ModLoader", "init", nosuchmethodexception2);
            ThrowException(nosuchmethodexception2);
        }
        File file = new File(Minecraft.getMinecraftDir(), "ModLoader.txt");
        try
        {
            logger.setLevel(Level.FINER);
            FileHandler filehandler = new FileHandler(file.getPath());
            filehandler.setFormatter(new SimpleFormatter());
            logger.addHandler(filehandler);
            File file1 = new File((ModLoader.class).getProtectionDomain().getCodeSource().getLocation().toURI());
            readFromClassPath(file1);
        }
        catch(Exception exception)
        {
            logger.throwing("ModLoader", "init", exception);
            ThrowException("ModLoader has failed to initialize.", exception);
        }
        hasInit = true;
        for(int j = 0; j < modList.size(); j++)
        {
            ((BaseMod)modList.get(j)).ModsLoaded();
        }

    }

    public static boolean isGUIOpen(Class class1)
    {
        Minecraft minecraft = getMinecraftInstance();
        if(minecraft == null)
        {
            return false;
        }
        if(class1 == null)
        {
            return minecraft.currentScreen == null;
        }
        if(minecraft.currentScreen == null && class1 != null)
        {
            return false;
        } else
        {
            return class1.isInstance(minecraft.currentScreen);
        }
    }

    public static boolean isModLoaded(String s)
    {
        if(!hasInit)
        {
            init();
        }
        Class class1 = null;
        try
        {
            class1 = Class.forName(s);
        }
        catch(ClassNotFoundException classnotfoundexception)
        {
            return false;
        }
        if(class1 != null)
        {
            for(int i = 0; i < modList.size(); i++)
            {
                if(class1.isInstance(modList.get(i)))
                {
                    return true;
                }
            }

        }
        return false;
    }

    private static java.awt.image.BufferedImage loadImage(RenderEngine renderengine, String s)
        throws Exception
    {
        TexturePackList texturepacklist = (TexturePackList)getPrivateValue(RenderEngine.class, renderengine, 10);
        InputStream inputstream = texturepacklist.selectedTexturePack.func_6481_a(s);
        if(inputstream == null)
        {
            throw new Exception((new StringBuilder("Image not found: ")).append(s).toString());
        }
        java.awt.image.BufferedImage bufferedimage = ImageIO.read(inputstream);
        if(bufferedimage == null)
        {
            throw new Exception((new StringBuilder("Image not found: ")).append(s).toString());
        } else
        {
            return bufferedimage;
        }
    }

    public static void OpenModGUI(EntityPlayer entityplayer, Object obj)
    {
        if(!hasInit)
        {
            init();
        }
        Minecraft minecraft = getMinecraftInstance();
        if(minecraft == null || minecraft.thePlayer != entityplayer)
        {
            return;
        }
        GuiScreen guiscreen = null;
        for(int i = 0; i < modList.size() && guiscreen == null; i++)
        {
            guiscreen = ((BaseMod)modList.get(i)).OpenModGUI(entityplayer, obj);
        }

        if(guiscreen != null)
        {
            minecraft.displayGuiScreen(guiscreen);
        }
    }

    public static void PopulateChunk(IChunkProvider ichunkprovider, int i, int j, World world)
    {
        if(!hasInit)
        {
            init();
        }
        for(int k = 0; k < modList.size(); k++)
        {
            if(ichunkprovider instanceof ChunkProviderGenerate)
            {
                ((BaseMod)modList.get(k)).GenerateSurface(world, world.rand, i, j);
            } else
            if(ichunkprovider instanceof ChunkProviderHell)
            {
                ((BaseMod)modList.get(k)).GenerateNether(world, world.rand, i, j);
            }
        }

    }
    
    private static void readFromClassPath(File file)
        throws FileNotFoundException, IOException
    {
        logger.finer((new StringBuilder("Adding mods from ")).append(file.getCanonicalPath()).toString());
        ClassLoader classloader = (ModLoader.class).getClassLoader();
        if(file.isFile() && (file.getName().endsWith(".jar") || file.getName().endsWith(".zip")))
        {
            logger.finer("Zip found.");
            ZipInputStream zipinputstream = new ZipInputStream(new FileInputStream(file));
            Object obj = null;
            do
            {
                ZipEntry zipentry = zipinputstream.getNextEntry();
                if(zipentry == null)
                {
                    break;
                }
                String s = zipentry.getName();
                if(!zipentry.isDirectory() && s.startsWith("mod_") && s.endsWith(".class"))
                {
                    addMod(classloader, s);
                }
            } while(true);
        } else
        if(file.isDirectory())
        {
            logger.finer("Directory found.");
            addModDirectory(file, classloader);
        }
    }
    
    // TODO
	private static List<String> addedMods = new ArrayList<String>();
	private static void addModDirectory(File file, ClassLoader classloader)
	{
		File afile[] = file.listFiles();
		if(afile != null)
		{
		    for(int i = 0; i < afile.length; i++)
		    {
		    	if(afile[i].isDirectory())
		    	{
		    		addModDirectory(afile[i], classloader);
		    	}
		    	else
		    	{
		    		String s1 = afile[i].getName();
			        if(afile[i].isFile() && s1.startsWith("mod_") && s1.endsWith(".class") && !addedMods.contains(s1))
			        {
			        	addedMods.add(s1);
			            addMod(classloader, "net.minecraft.src." + s1);
			        }
		    	}
		    }
		}
	}

    public static void RegisterAllTextureOverrides(RenderEngine renderengine)
    {
        for(int i = 0; i < modList.size(); i++)
        {
            ((BaseMod)modList.get(i)).RegisterTextureOverrides();
        }

        Minecraft minecraft = getMinecraftInstance();
        if(minecraft != null)
        {
            for(int j = 0; j < modList.size(); j++)
            {
                ((BaseMod)modList.get(j)).RegisterAnimation(minecraft);
            }

        }
        for(int k = 0; k < animList.size(); k++)
        {
            renderengine.registerTextureFX((TextureFX)animList.get(k));
        }

        for(Iterator iterator = overrides.entrySet().iterator(); iterator.hasNext();)
        {
            java.util.Map.Entry entry = (java.util.Map.Entry)iterator.next();
            String s = (String)entry.getKey();
            int l = renderengine.getTexture(s);
            GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, l);
            IntBuffer intbuffer = ByteBuffer.allocateDirect(16).order(ByteOrder.nativeOrder()).asIntBuffer();
            GL11.glGetTexLevelParameter(3553 /*GL_TEXTURE_2D*/, 0, 4097 /*GL_TEXTURE_HEIGHT*/, intbuffer);
            int i1 = intbuffer.get(0);
            int j1 = i1 / 16;
            List list = (List)entry.getValue();
            for(Iterator iterator1 = list.iterator(); iterator1.hasNext();)
            {
                java.util.AbstractMap.SimpleEntry simpleentry = (java.util.AbstractMap.SimpleEntry)iterator1.next();
                String s1 = (String)simpleentry.getKey();
                int k1 = ((Integer)simpleentry.getValue()).intValue();
                System.out.println((new StringBuilder("Overriding ")).append(s).append(" with ").append(s1).append(" @ ").append(k1).toString());
                int l1;
                int i2;
                int ai[];
                try
                {
                    java.awt.image.BufferedImage bufferedimage = loadImage(renderengine, s1);
                    l1 = bufferedimage.getHeight();
                    i2 = j1 / l1;
                    ai = new int[l1 * l1];
                    bufferedimage.getRGB(0, 0, l1, l1, ai, 0, l1);
                }
                catch(Exception exception)
                {
                    logger.throwing("ModLoader", "RegisterAllTextureOverrides", exception);
                    ThrowException(exception);
                    return;
                }
                int j2 = k1 / 16;
                int k2 = k1 % 16;
                int l2 = j1 * j2;
                int i3 = j1 * k2;
                ByteBuffer bytebuffer = ByteBuffer.allocateDirect(4 * j1 * j1).order(ByteOrder.nativeOrder());
                for(int j3 = 0; j3 < j1; j3++)
                {
                    for(int k3 = 0; k3 < j1; k3++)
                    {
                        int l3 = i2 == 0 ? l1 * (j3 * (l1 / j1)) + k3 * (l1 / j1) : l1 * (j3 / i2) + k3 / i2;
                        int i4 = ai[l3];
                        byte byte0 = (byte)(i4 >> 24 & 0xff);
                        byte byte1 = (byte)(i4 >> 16 & 0xff);
                        byte byte2 = (byte)(i4 >> 8 & 0xff);
                        byte byte3 = (byte)(i4 & 0xff);
                        bytebuffer.put(byte1);
                        bytebuffer.put(byte2);
                        bytebuffer.put(byte3);
                        bytebuffer.put(byte0);
                    }

                }

                bytebuffer.position(0);
                try
                {
                    method_glTexSubImage2D.invoke(null, new Object[] {
                        Integer.valueOf(3553 /*GL_TEXTURE_2D*/), Integer.valueOf(0), Integer.valueOf(i3), Integer.valueOf(l2), Integer.valueOf(j1), Integer.valueOf(j1), Integer.valueOf(6408 /*GL_RGBA*/), Integer.valueOf(5121 /*GL_UNSIGNED_BYTE*/), bytebuffer
                    });
                }
                catch(Exception exception1)
                {
                    logger.throwing("ModLoader", "RegisterAllTextureOverrides", exception1);
                    ThrowException("Error calling glTexSubImage2D (blame xau)", exception1);
                }
            }

        }

    }

    public static void RegisterBlock(Block block)
    {
        RegisterBlock(block, null);
    }

    public static void RegisterBlock(Block block, Class class1)
    {
        try
        {
            List list = (List)field_blockList.get(null);
            list.add(block);
            field_blockList.set(null, list);
            int i = block.blockID;
            ItemBlock itemblock = null;
            if(class1 != null)
            {
                itemblock = (ItemBlock)class1.getConstructor(new Class[] {
                    Integer.TYPE
                }).newInstance(new Object[] {
                    Integer.valueOf(i - 256)
                });
            } else
            {
                itemblock = new ItemBlock(i - 256);
            }
            if(Block.blocksList[i] != null && Item.itemsList[i] == null)
            {
                Item.itemsList[i] = itemblock;
            }
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", illegalargumentexception);
            ThrowException(illegalargumentexception);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", illegalaccessexception);
            ThrowException(illegalaccessexception);
        }
        catch(SecurityException securityexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", securityexception);
            ThrowException(securityexception);
        }
        catch(InstantiationException instantiationexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", instantiationexception);
            ThrowException(instantiationexception);
        }
        catch(InvocationTargetException invocationtargetexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", invocationtargetexception);
            ThrowException(invocationtargetexception);
        }
        catch(NoSuchMethodException nosuchmethodexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", nosuchmethodexception);
            ThrowException(nosuchmethodexception);
        }
    }

    public static void RegisterEntityID(Class class1, String s, int i)
    {
        try
        {
            method_RegisterEntityID.invoke(null, new Object[] {
                class1, s, Integer.valueOf(i)
            });
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            logger.throwing("ModLoader", "RegisterEntityID", illegalargumentexception);
            ThrowException(illegalargumentexception);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "RegisterEntityID", illegalaccessexception);
            ThrowException(illegalaccessexception);
        }
        catch(InvocationTargetException invocationtargetexception)
        {
            logger.throwing("ModLoader", "RegisterEntityID", invocationtargetexception);
            ThrowException(invocationtargetexception);
        }
    }

    public static void RegisterTileEntity(Class class1, String s)
    {
        try
        {
            method_RegisterTileEntity.invoke(null, new Object[] {
                class1, s
            });
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            logger.throwing("ModLoader", "RegisterTileEntity", illegalargumentexception);
            ThrowException(illegalargumentexception);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "RegisterTileEntity", illegalaccessexception);
            ThrowException(illegalaccessexception);
        }
        catch(InvocationTargetException invocationtargetexception)
        {
            logger.throwing("ModLoader", "RegisterTileEntity", invocationtargetexception);
            ThrowException(invocationtargetexception);
        }
    }

    public static void RunOSDHooks(Minecraft minecraft)
    {
        if(!hasInit)
        {
            init();
        }
        for(int i = 0; i < modList.size(); i++)
        {
            ((BaseMod)modList.get(i)).OSDHook(minecraft, minecraft.currentScreen != null);
        }

    }

    public static void setPrivateValue(Class class1, Object obj, int i, Object obj1)
        throws IllegalArgumentException, SecurityException, NoSuchFieldException
    {
        try
        {
            Field field = class1.getDeclaredFields()[i];
            field.setAccessible(true);
            int j = field_modifiers.getInt(field);
            if((j & 0x10) != 0)
            {
                field_modifiers.setInt(field, j & 0xffffffef);
            }
            field.set(obj, obj1);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "setPrivateValue", illegalaccessexception);
            ThrowException("An impossible error has occured!", illegalaccessexception);
        }
    }

    public static void setPrivateValue(Class class1, Object obj, String s, Object obj1)
        throws IllegalArgumentException, SecurityException, NoSuchFieldException
    {
        try
        {
            Field field = class1.getDeclaredField(s);
            int i = field_modifiers.getInt(field);
            if((i & 0x10) != 0)
            {
                field_modifiers.setInt(field, i & 0xffffffef);
            }
            field.setAccessible(true);
            field.set(obj, obj1);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "setPrivateValue", illegalaccessexception);
            ThrowException("An impossible error has occured!", illegalaccessexception);
        }
    }

    public static void ThrowException(String s, Throwable throwable)
    {
        Minecraft minecraft = getMinecraftInstance();
        if(minecraft != null)
        {
            minecraft.displayUnexpectedThrowable(new UnexpectedThrowable(s, throwable));
        } else
        {
            throw new RuntimeException(throwable);
        }
    }

    private static void ThrowException(Throwable throwable)
    {
        ThrowException("Exception occured in ModLoader", throwable);
    }

    private ModLoader()
    {
    }

    private static final List animList = new ArrayList();
    private static Field field_blockList = null;
    private static Field field_modifiers = null;
    private static boolean hasInit = false;
    private static int highestEntityId = 3000;
    private static Minecraft instance = null;
    private static int itemSpriteIndex = 0;
    private static final Logger logger = Logger.getLogger("ModLoader");
    private static Method method_glTexSubImage2D = null;
    private static Method method_RegisterEntityID = null;
    private static Method method_RegisterTileEntity = null;
    private static final List modList = new ArrayList();
    private static final Map overrides = new HashMap();
    private static int terrainSpriteIndex = 0;
    private static final boolean usedItemSprites[] = new boolean[256];
    private static final boolean usedTerrainSprites[] = new boolean[256];

    // SDK
    public static void AddAllNetClientHandlerEntities()
    {
    	if(!hasInit)
        {
            init();
        }
    	
    	netClientHandlerEntityMap = new HashMap<Integer, Class>();
    	for(int i = 0; i < modList.size(); i++)
        {
            ((BaseMod)modList.get(i)).AddNetClientHandlerEntities(netClientHandlerEntityMap);
        }
    }

	public static Class HandleNetClientHandlerEntities(int id)
	{
		if(!hasInit)
        {
            init();
        }
		if(netClientHandlerEntityMap == null)
		{
			AddAllNetClientHandlerEntities();
		}
        
		if(netClientHandlerEntityMap.containsKey(id))
		{
			return netClientHandlerEntityMap.get(id);
		}
		else
		{
	        return null;
		}
	}
	
	public static int AddArmor(String armor) {
		try {
			String[] existingArmor = (String[]) field_armorList.get(null);
			List<String> existingArmorList = Arrays.asList(existingArmor);
			List<String> combinedList = new ArrayList<String>();
			combinedList.addAll(existingArmorList);
			if (!combinedList.contains(armor))
				combinedList.add(armor);
			int index = combinedList.indexOf(armor);
			field_armorList.set(null, combinedList.toArray(new String[0]));
			return index;
		} catch (IllegalArgumentException e) {
			logger.throwing("ModLoader", "AddArmor", e);
			ThrowException("An impossible error has occured!", e);
		} catch (IllegalAccessException e) {
			logger.throwing("ModLoader", "AddArmor", e);
			ThrowException("An impossible error has occured!", e);
		}
		return -1;
	}
	
	public static boolean RenderAllBlocks(RenderBlocks renderBlocks, Block block,
			int i, int j, int k, int l, IBlockAccess blockAccess,
			int overrideBlockTexture, boolean renderAllFaces)
	{
		if(!hasInit)
        {
            init();
        }
        
		for(int m = 0; m < modList.size(); m++)
        {
            if (((BaseMod)modList.get(m)).RenderBlocks(renderBlocks, block, i, j, k, l, blockAccess, overrideBlockTexture, renderAllFaces))
            {
            	return true;
            }
        }
		
		return false;
	}
	
	public static void SendPacket(BaseMod baseMod, Packet200ModLoader packet200ModLoader)
	{
		if(baseMod == null)
		{
			throw new IllegalArgumentException("baseMod cannot be null.");
		}
		
		packet200ModLoader.modId = baseMod.getId();
		SendPacket(packet200ModLoader);
	}
	
	private static void SendPacket(Packet200ModLoader packet200ModLoader)
	{
		if(!hasInit)
        {
            init();
        }
		if(instance == null)
		{
			getMinecraftInstance();
		}
		
		if(instance.theWorld != null && instance.theWorld.multiplayerWorld)
		{
			instance.func_20001_q().addToSendQueue(packet200ModLoader);
		}
	}

	public static void HandleAllPackets(Packet200ModLoader packet200ModLoader)
	{
		if(!hasInit)
        {
            init();
        }
		
		if(packet200ModLoader.modId == "ModLoader".hashCode())
		{
			handleModCheck(packet200ModLoader);
		}
		else
		{
			for(int m = 0; m < modList.size(); m++)
	        {
				if (((BaseMod)modList.get(m)).getId() == packet200ModLoader.modId)
	            {
	            	((BaseMod)modList.get(m)).HandlePacket(packet200ModLoader);
	            	break;
	            }
	        }
		}
	}

	private static void handleModCheck(Packet200ModLoader packet200ModLoader)
	{
		// Check for missing mods
		List<String> modsMissing = new ArrayList<String>();
		for(int i = 0; i < packet200ModLoader.dataString.length; i++)
		{
			boolean modFound = false;
			for(int j = 0; j < modList.size(); j++)
			{
				if(((BaseMod)modList.get(j)).toString() == packet200ModLoader.dataString[i])
				{
					modFound = true;
					break;
				}
			}
			
			if(!modFound)
			{
				modsMissing.add(packet200ModLoader.dataString[i]);
			}
		}
		
		// Respond with missing mods
		Packet200ModLoader packetModCheckResponse = new Packet200ModLoader();
		packetModCheckResponse.modId = "ModLoader".hashCode();
		packetModCheckResponse.dataString = new String[modsMissing.size()];
		modsMissing.toArray(packetModCheckResponse.dataString);
		SendPacket(packetModCheckResponse);
	}
	
	private static void addCustomPacketMapping()
	{
		try
		{
			method_AddIdClassMapping.invoke(null, 200, Packet200ModLoader.class);
		}
		catch (InvocationTargetException invocationtargetexception)
		{
			logger.throwing("ModLoader", "AddCustomPacketMapping", invocationtargetexception);
            ThrowException(invocationtargetexception);
		}
		catch (IllegalAccessException illegalaccessexception)
		{
			logger.throwing("ModLoader", "AddCustomPacketMapping", illegalaccessexception);
            ThrowException(illegalaccessexception);
		}
	}

	private static Map<Integer, Class> netClientHandlerEntityMap = null;
    private static Field field_armorList;
	private static Method method_AddIdClassMapping = null;
}
